/*
 * Copyright 2012 Stanley Shyiko
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.github.shyiko.ump;

import org.apache.maven.AbstractMavenLifecycleParticipant;
import org.apache.maven.execution.MavenSession;
import org.codehaus.plexus.component.annotations.Component;

import java.util.Arrays;

/**
 * @author <a href="mailto:stanley.shyiko@gmail.com">Stanley Shyiko</a>
 */
@Component(role = AbstractMavenLifecycleParticipant.class)
public class NonRecursiveExtension extends AbstractMavenLifecycleParticipant {

    public void afterProjectsRead(MavenSession session) {
        if (session.getGoals().isEmpty() && session.getUserProperties().isEmpty()) {
            session.setProjects(Arrays.asList(session.getTopLevelProject()));
            if (session.getCurrentProject().getDefaultGoal() == null) {
                session.getGoals().add("usage:show");
            }
        }
    }
}